<template>
  <main id="app" @mousemove="mousemove">
    <section class="products">
      <Product
        v-for="product in products"
        :key="product.color"
        :product="product"
      />
    </section>
  </main>
</template>

<script>
import Product from './components/VueMouse.vue';
export default {
  name: 'app',
  components: {
    Product
  },
  data () {
    return {
      products: [
        {
          color: 'green',
          src: require('./assets/vue-logo.png')
        },
        {
          color: 'blue',
          src: require('./assets/vue-logo.png')
        },
        {
          color: 'pink',
          src: require('./assets/vue-logo.png')
        },

         {
       
          color: 'violet',
          src: require('./assets/vue-logo.png')
        },
   
        
        
      ]
    }
  },
  methods: {
    mousemove (e) {
      let mouseX = e.clientX;
      let mouseY = e.clientY;
      let products = document.querySelectorAll('.products .product');
      for (let i = 0; i < products.length; i++) {
        let product = products[i];
        let product_image = product.querySelector('.product-image-wrap');
        let img_x = mouseX - this.coords(product_image).x;
        let img_y = mouseY - this.coords(product_image).y;
        product_image.style.transform = `translateY(-${img_y/40}px) translateX(-${img_x/40}px) translateZ(100px)`;
      }
    },
    coords (el) {
      let coords = el.getBoundingClientRect();
      return {
        x: coords.left / 2,
        y: coords.top / 2
      }
    }
  }
}
</script>

<style>
  * {
    margin: 0;
    padding: 0;
    box-sizing: border-box;
  }

  main {
    width: 75vw;
    min-height: 50vh;
    overflow: hidden;
    display: flex;
    justify-content: center;
    align-items: center;
    
  }
  .products {
    display: flex;
    max-width: 1280px;

  }
</style>